{
  This file was automatically generated on 2024-04-08.

  Delphi/Lazarus Bindings Version 2.1.34

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletEnergyMonitor;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_ENERGY_MONITOR_DEVICE_IDENTIFIER = 2152;
  BRICKLET_ENERGY_MONITOR_DEVICE_DISPLAY_NAME = 'Energy Monitor Bricklet';

  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_ENERGY_DATA = 1;
  BRICKLET_ENERGY_MONITOR_FUNCTION_RESET_ENERGY = 2;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_WAVEFORM_LOW_LEVEL = 3;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_TRANSFORMER_STATUS = 4;
  BRICKLET_ENERGY_MONITOR_FUNCTION_SET_TRANSFORMER_CALIBRATION = 5;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_TRANSFORMER_CALIBRATION = 6;
  BRICKLET_ENERGY_MONITOR_FUNCTION_CALIBRATE_OFFSET = 7;
  BRICKLET_ENERGY_MONITOR_FUNCTION_SET_ENERGY_DATA_CALLBACK_CONFIGURATION = 8;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_ENERGY_DATA_CALLBACK_CONFIGURATION = 9;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_SPITFP_ERROR_COUNT = 234;
  BRICKLET_ENERGY_MONITOR_FUNCTION_SET_BOOTLOADER_MODE = 235;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_BOOTLOADER_MODE = 236;
  BRICKLET_ENERGY_MONITOR_FUNCTION_SET_WRITE_FIRMWARE_POINTER = 237;
  BRICKLET_ENERGY_MONITOR_FUNCTION_WRITE_FIRMWARE = 238;
  BRICKLET_ENERGY_MONITOR_FUNCTION_SET_STATUS_LED_CONFIG = 239;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_STATUS_LED_CONFIG = 240;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_CHIP_TEMPERATURE = 242;
  BRICKLET_ENERGY_MONITOR_FUNCTION_RESET = 243;
  BRICKLET_ENERGY_MONITOR_FUNCTION_WRITE_UID = 248;
  BRICKLET_ENERGY_MONITOR_FUNCTION_READ_UID = 249;
  BRICKLET_ENERGY_MONITOR_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_ENERGY_MONITOR_CALLBACK_ENERGY_DATA = 10;

  BRICKLET_ENERGY_MONITOR_BOOTLOADER_MODE_BOOTLOADER = 0;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_MODE_FIRMWARE = 1;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT = 2;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT = 3;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT = 4;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_STATUS_OK = 0;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_STATUS_INVALID_MODE = 1;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_STATUS_NO_CHANGE = 2;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT = 3;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT = 4;
  BRICKLET_ENERGY_MONITOR_BOOTLOADER_STATUS_CRC_MISMATCH = 5;
  BRICKLET_ENERGY_MONITOR_STATUS_LED_CONFIG_OFF = 0;
  BRICKLET_ENERGY_MONITOR_STATUS_LED_CONFIG_ON = 1;
  BRICKLET_ENERGY_MONITOR_STATUS_LED_CONFIG_SHOW_HEARTBEAT = 2;
  BRICKLET_ENERGY_MONITOR_STATUS_LED_CONFIG_SHOW_STATUS = 3;

type
  TArray0To29OfInt16 = array [0..29] of smallint;
  TArray0To2OfUInt8 = array [0..2] of byte;
  TArray0To63OfUInt8 = array [0..63] of byte;
  TArrayOfInt16 = array of smallint;

  TBrickletEnergyMonitor = class;
  TBrickletEnergyMonitorNotifyEnergyData = procedure(sender: TBrickletEnergyMonitor; const voltage: longint; const current: longint; const energy: longint; const realPower: longint; const apparentPower: longint; const reactivePower: longint; const powerFactor: word; const frequency: word) of object;

  /// <summary>
  ///  Measures Voltage, Current, Energy, Real/Apparent/Reactive Power, Power Factor and Frequency
  /// </summary>
  TBrickletEnergyMonitor = class(TDevice)
  private
    streamMutex: TCriticalSection;
    energyDataCallback: TBrickletEnergyMonitorNotifyEnergyData;
  protected
    procedure CallbackWrapperEnergyData(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns all of the measurements that are done by the Energy Monitor Bricklet.
    ///  
    ///  * Voltage RMS
    ///  * Current RMS
    ///  * Energy (integrated over time)
    ///  * Real Power
    ///  * Apparent Power
    ///  * Reactive Power
    ///  * Power Factor
    ///  * Frequency (AC Frequency of the mains voltage)
    ///  
    ///  The frequency is recalculated every 6 seconds.
    ///  
    ///  All other values are integrated over 10 zero-crossings of the voltage sine wave.
    ///  With a standard AC mains voltage frequency of 50Hz this results in a 5 measurements
    ///  per second (or an integration time of 200ms per measurement).
    ///  
    ///  If no voltage transformer is connected, the Bricklet will use the current waveform
    ///  to calculate the frequency and it will use an integration time of
    ///  10 zero-crossings of the current waveform.
    /// </summary>
    procedure GetEnergyData(out voltage: longint; out current: longint; out energy: longint; out realPower: longint; out apparentPower: longint; out reactivePower: longint; out powerFactor: word; out frequency: word); virtual;

    /// <summary>
    ///  Sets the energy value (see <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.GetEnergyData"/>) back to 0Wh.
    /// </summary>
    procedure ResetEnergy; virtual;

    /// <summary>
    ///  Returns a snapshot of the voltage and current waveform. The values
    ///  in the returned array alternate between voltage and current. The data from
    ///  one getter call contains 768 data points for voltage and current, which
    ///  correspond to about 3 full sine waves.
    ///  
    ///  The voltage is given with a resolution of 100mV and the current is given
    ///  with a resolution of 10mA.
    ///  
    ///  This data is meant to be used for a non-realtime graphical representation of
    ///  the voltage and current waveforms.
    /// </summary>
    procedure GetWaveformLowLevel(out waveformChunkOffset: word; out waveformChunkData: TArray0To29OfInt16); virtual;

    /// <summary>
    ///  Returns a snapshot of the voltage and current waveform. The values
    ///  in the returned array alternate between voltage and current. The data from
    ///  one getter call contains 768 data points for voltage and current, which
    ///  correspond to about 3 full sine waves.
    ///  
    ///  The voltage is given with a resolution of 100mV and the current is given
    ///  with a resolution of 10mA.
    ///  
    ///  This data is meant to be used for a non-realtime graphical representation of
    ///  the voltage and current waveforms.
    /// </summary>
    function GetWaveform: TArrayOfInt16; virtual;

    /// <summary>
    ///  Returns *true* if a voltage/current transformer is connected to the Bricklet.
    /// </summary>
    procedure GetTransformerStatus(out voltageTransformerConnected: boolean; out currentTransformerConnected: boolean); virtual;

    /// <summary>
    ///  Sets the transformer ratio for the voltage and current transformer in 1/100 form.
    ///  
    ///  Example: If your mains voltage is 230V, you use 9V voltage transformer and a
    ///  1V:30A current clamp your voltage ratio is 230/9 = 25.56 and your current ratio
    ///  is 30/1 = 30.
    ///  
    ///  In this case you have to set the values 2556 and 3000 for voltage ratio and current
    ///  ratio.
    ///  
    ///  The calibration is saved in non-volatile memory, you only have to set it once.
    ///  
    ///  Set the phase shift to 0. It is for future use and currently not supported by the Bricklet.
    /// </summary>
    procedure SetTransformerCalibration(const voltageRatio: word; const currentRatio: word; const phaseShift: smallint); virtual;

    /// <summary>
    ///  Returns the transformer calibration as set by <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.SetTransformerCalibration"/>.
    /// </summary>
    procedure GetTransformerCalibration(out voltageRatio: word; out currentRatio: word; out phaseShift: smallint); virtual;

    /// <summary>
    ///  Calling this function will start an offset calibration. The offset calibration will
    ///  integrate the voltage and current waveform over a longer time period to find the 0
    ///  transition point in the sine wave.
    ///  
    ///  The Bricklet comes with a factory-calibrated offset value, you should not have to
    ///  call this function.
    ///  
    ///  If you want to re-calibrate the offset we recommend that you connect a load that
    ///  has a smooth sinusoidal voltage and current waveform. Alternatively you can also
    ///  short both inputs.
    ///  
    ///  The calibration is saved in non-volatile memory, you only have to set it once.
    /// </summary>
    procedure CalibrateOffset; virtual;

    /// <summary>
    ///  The period is the period with which the <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.OnEnergyData"/>
    ///  callback is triggered periodically. A value of 0 turns the callback off.
    ///  
    ///  If the `value has to change`-parameter is set to true, the callback is only
    ///  triggered after the value has changed. If the value didn't change within the
    ///  period, the callback is triggered immediately on change.
    ///  
    ///  If it is set to false, the callback is continuously triggered with the period,
    ///  independent of the value.
    /// </summary>
    procedure SetEnergyDataCallbackConfiguration(const period: longword; const valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns the callback configuration as set by
    ///  <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.SetEnergyDataCallbackConfiguration"/>.
    /// </summary>
    procedure GetEnergyDataCallbackConfiguration(out period: longword; out valueHasToChange: boolean); virtual;

    /// <summary>
    ///  Returns the error count for the communication between Brick and Bricklet.
    ///  
    ///  The errors are divided into
    ///  
    ///  * ACK checksum errors,
    ///  * message checksum errors,
    ///  * framing errors and
    ///  * overflow errors.
    ///  
    ///  The errors counts are for errors that occur on the Bricklet side. All
    ///  Bricks have a similar function that returns the errors on the Brick side.
    /// </summary>
    procedure GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword); virtual;

    /// <summary>
    ///  Sets the bootloader mode and returns the status after the requested
    ///  mode change was instigated.
    ///  
    ///  You can change from bootloader mode to firmware mode and vice versa. A change
    ///  from bootloader mode to firmware mode will only take place if the entry function,
    ///  device identifier and CRC are present and correct.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function SetBootloaderMode(const mode: byte): byte; virtual;

    /// <summary>
    ///  Returns the current bootloader mode, see <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.SetBootloaderMode"/>.
    /// </summary>
    function GetBootloaderMode: byte; virtual;

    /// <summary>
    ///  Sets the firmware pointer for <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.WriteFirmware"/>. The pointer has
    ///  to be increased by chunks of size 64. The data is written to flash
    ///  every 4 chunks (which equals to one page of size 256).
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    procedure SetWriteFirmwarePointer(const pointer: longword); virtual;

    /// <summary>
    ///  Writes 64 Bytes of firmware at the position as written by
    ///  <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.SetWriteFirmwarePointer"/> before. The firmware is written
    ///  to flash every 4 chunks.
    ///  
    ///  You can only write firmware in bootloader mode.
    ///  
    ///  This function is used by Brick Viewer during flashing. It should not be
    ///  necessary to call it in a normal user program.
    /// </summary>
    function WriteFirmware(const data: array of byte): byte; virtual;

    /// <summary>
    ///  Sets the status LED configuration. By default the LED shows
    ///  communication traffic between Brick and Bricklet, it flickers once
    ///  for every 10 received data packets.
    ///  
    ///  You can also turn the LED permanently on/off or show a heartbeat.
    ///  
    ///  If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    /// </summary>
    procedure SetStatusLEDConfig(const config: byte); virtual;

    /// <summary>
    ///  Returns the configuration as set by <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.SetStatusLEDConfig"/>
    /// </summary>
    function GetStatusLEDConfig: byte; virtual;

    /// <summary>
    ///  Returns the temperature as measured inside the microcontroller. The
    ///  value returned is not the ambient temperature!
    ///  
    ///  The temperature is only proportional to the real temperature and it has bad
    ///  accuracy. Practically it is only useful as an indicator for
    ///  temperature changes.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Calling this function will reset the Bricklet. All configurations
    ///  will be lost.
    ///  
    ///  After a reset you have to create new device objects,
    ///  calling functions on the existing ones will result in
    ///  undefined behavior!
    /// </summary>
    procedure Reset; virtual;

    /// <summary>
    ///  Writes a new UID into flash. If you want to set a new UID
    ///  you have to decode the Base58 encoded UID string into an
    ///  integer first.
    ///  
    ///  We recommend that you use Brick Viewer to change the UID.
    /// </summary>
    procedure WriteUID(const uid: longword); virtual;

    /// <summary>
    ///  Returns the current UID as an integer. Encode as
    ///  Base58 to get the usual string version.
    /// </summary>
    function ReadUID: longword; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically according to the configuration set by
    ///  <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.SetEnergyDataCallbackConfiguration"/>.
    ///  
    ///  The parameters are the same as <see cref="BrickletEnergyMonitor.TBrickletEnergyMonitor.GetEnergyData"/>.
    /// </summary>
    property OnEnergyData: TBrickletEnergyMonitorNotifyEnergyData read energyDataCallback write energyDataCallback;
  end;

implementation

constructor TBrickletEnergyMonitor.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_ENERGY_MONITOR_DEVICE_IDENTIFIER, BRICKLET_ENERGY_MONITOR_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 0;

  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_ENERGY_DATA] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_RESET_ENERGY] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_WAVEFORM_LOW_LEVEL] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_TRANSFORMER_STATUS] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_SET_TRANSFORMER_CALIBRATION] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_TRANSFORMER_CALIBRATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_CALIBRATE_OFFSET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_SET_ENERGY_DATA_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_ENERGY_DATA_CALLBACK_CONFIGURATION] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_SPITFP_ERROR_COUNT] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_SET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_BOOTLOADER_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_SET_WRITE_FIRMWARE_POINTER] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_WRITE_FIRMWARE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_SET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_STATUS_LED_CONFIG] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_RESET] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_WRITE_UID] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_READ_UID] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_ENERGY_MONITOR_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  streamMutex := TCriticalSection.Create;

  callbackWrappers[BRICKLET_ENERGY_MONITOR_CALLBACK_ENERGY_DATA] := {$ifdef FPC}@{$endif}CallbackWrapperEnergyData;

  (ipcon as TIPConnection).AddDevice(self);
end;

procedure TBrickletEnergyMonitor.GetEnergyData(out voltage: longint; out current: longint; out energy: longint; out realPower: longint; out apparentPower: longint; out reactivePower: longint; out powerFactor: word; out frequency: word);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_ENERGY_DATA, 8);
  response := SendRequest(request, 36);
  voltage := LEConvertInt32From(8, response);
  current := LEConvertInt32From(12, response);
  energy := LEConvertInt32From(16, response);
  realPower := LEConvertInt32From(20, response);
  apparentPower := LEConvertInt32From(24, response);
  reactivePower := LEConvertInt32From(28, response);
  powerFactor := LEConvertUInt16From(32, response);
  frequency := LEConvertUInt16From(34, response);
end;

procedure TBrickletEnergyMonitor.ResetEnergy;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_RESET_ENERGY, 8);
  SendRequest(request, 0);
end;

procedure TBrickletEnergyMonitor.GetWaveformLowLevel(out waveformChunkOffset: word; out waveformChunkData: TArray0To29OfInt16);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_WAVEFORM_LOW_LEVEL, 8);
  response := SendRequest(request, 70);
  waveformChunkOffset := LEConvertUInt16From(8, response);
  for i := 0 to 29 do waveformChunkData[i] := LEConvertInt16From(10 + (i * 2), response);
end;

function TBrickletEnergyMonitor.GetWaveform: TArrayOfInt16;
var
  waveform: TArrayOfInt16;
  waveformCurrentLength: word;
  waveformLength: word;
  waveformChunkOffset: word;
  waveformChunkData: TArray0To29OfInt16;
  waveformOutOfSync: boolean;
  waveformChunkLength: word;
begin
  result := []; { avoid compiler warning "function result variable of a managed type does not seem to be initialized" }
  SetLength(result, 0);
  SetLength(waveform, 0);
  streamMutex.Acquire;
  try
    waveformLength := 1536;
    GetWaveformLowLevel(waveformChunkOffset, waveformChunkData);
    SetLength(waveform, waveformLength);

    if (waveformChunkOffset = ((1 shl 16) - 1)) then begin { Maximum chunk offset -> stream has no data }
      SetLength(waveform, 0);
      exit;
    end;

    waveformOutOfSync := (waveformChunkOffset <> 0);

    if ((not waveformOutOfSync) and (waveformLength > 0)) then begin
      waveformChunkLength := waveformLength - waveformChunkOffset;
      if (waveformChunkLength > 30) then waveformChunkLength := 30;
      Move(waveformChunkData, waveform[0], SizeOf(smallint) * waveformChunkLength);
      waveformCurrentLength := waveformChunkLength;

      while ((not waveformOutOfSync) and (waveformCurrentLength < waveformLength)) do begin
        GetWaveformLowLevel(waveformChunkOffset, waveformChunkData);
        waveformOutOfSync := waveformChunkOffset <> waveformCurrentLength;
        waveformChunkLength := waveformLength - waveformChunkOffset;
        if (waveformChunkLength > 30) then waveformChunkLength := 30;
        Move(waveformChunkData, waveform[waveformCurrentLength], SizeOf(smallint) * waveformChunkLength);
        Inc(waveformCurrentLength, waveformChunkLength);
      end;
    end;

    if (waveformOutOfSync) then begin
      { Discard remaining stream to bring it back in-sync }
      while (waveformChunkOffset + 30 < waveformLength) do begin
        GetWaveformLowLevel(waveformChunkOffset, waveformChunkData);
      end;

      raise EStreamOutOfSyncException.Create('Waveform stream out-of-sync');
    end;
  finally
    streamMutex.Release;
  end;
  result := waveform;
end;

procedure TBrickletEnergyMonitor.GetTransformerStatus(out voltageTransformerConnected: boolean; out currentTransformerConnected: boolean);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_TRANSFORMER_STATUS, 8);
  response := SendRequest(request, 10);
  voltageTransformerConnected := LEConvertBooleanFrom(8, response);
  currentTransformerConnected := LEConvertBooleanFrom(9, response);
end;

procedure TBrickletEnergyMonitor.SetTransformerCalibration(const voltageRatio: word; const currentRatio: word; const phaseShift: smallint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_SET_TRANSFORMER_CALIBRATION, 14);
  LEConvertUInt16To(voltageRatio, 8, request);
  LEConvertUInt16To(currentRatio, 10, request);
  LEConvertInt16To(phaseShift, 12, request);
  SendRequest(request, 0);
end;

procedure TBrickletEnergyMonitor.GetTransformerCalibration(out voltageRatio: word; out currentRatio: word; out phaseShift: smallint);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_TRANSFORMER_CALIBRATION, 8);
  response := SendRequest(request, 14);
  voltageRatio := LEConvertUInt16From(8, response);
  currentRatio := LEConvertUInt16From(10, response);
  phaseShift := LEConvertInt16From(12, response);
end;

procedure TBrickletEnergyMonitor.CalibrateOffset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_CALIBRATE_OFFSET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletEnergyMonitor.SetEnergyDataCallbackConfiguration(const period: longword; const valueHasToChange: boolean);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_SET_ENERGY_DATA_CALLBACK_CONFIGURATION, 13);
  LEConvertUInt32To(period, 8, request);
  LEConvertBooleanTo(valueHasToChange, 12, request);
  SendRequest(request, 0);
end;

procedure TBrickletEnergyMonitor.GetEnergyDataCallbackConfiguration(out period: longword; out valueHasToChange: boolean);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_ENERGY_DATA_CALLBACK_CONFIGURATION, 8);
  response := SendRequest(request, 13);
  period := LEConvertUInt32From(8, response);
  valueHasToChange := LEConvertBooleanFrom(12, response);
end;

procedure TBrickletEnergyMonitor.GetSPITFPErrorCount(out errorCountAckChecksum: longword; out errorCountMessageChecksum: longword; out errorCountFrame: longword; out errorCountOverflow: longword);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_SPITFP_ERROR_COUNT, 8);
  response := SendRequest(request, 24);
  errorCountAckChecksum := LEConvertUInt32From(8, response);
  errorCountMessageChecksum := LEConvertUInt32From(12, response);
  errorCountFrame := LEConvertUInt32From(16, response);
  errorCountOverflow := LEConvertUInt32From(20, response);
end;

function TBrickletEnergyMonitor.SetBootloaderMode(const mode: byte): byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_SET_BOOTLOADER_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletEnergyMonitor.GetBootloaderMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_BOOTLOADER_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletEnergyMonitor.SetWriteFirmwarePointer(const pointer: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_SET_WRITE_FIRMWARE_POINTER, 12);
  LEConvertUInt32To(pointer, 8, request);
  SendRequest(request, 0);
end;

function TBrickletEnergyMonitor.WriteFirmware(const data: array of byte): byte;
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_WRITE_FIRMWARE, 72);
  if (Length(data) <> 64) then raise EInvalidParameterException.Create('Data has to be exactly 64 items long');
  for i := 0 to Length(data) - 1 do LEConvertUInt8To(data[i], 8 + (i * 1), request);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletEnergyMonitor.SetStatusLEDConfig(const config: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_SET_STATUS_LED_CONFIG, 9);
  LEConvertUInt8To(config, 8, request);
  SendRequest(request, 0);
end;

function TBrickletEnergyMonitor.GetStatusLEDConfig: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_STATUS_LED_CONFIG, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

function TBrickletEnergyMonitor.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

procedure TBrickletEnergyMonitor.Reset;
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_RESET, 8);
  SendRequest(request, 0);
end;

procedure TBrickletEnergyMonitor.WriteUID(const uid: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_WRITE_UID, 12);
  LEConvertUInt32To(uid, 8, request);
  SendRequest(request, 0);
end;

function TBrickletEnergyMonitor.ReadUID: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_READ_UID, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletEnergyMonitor.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_ENERGY_MONITOR_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletEnergyMonitor.CallbackWrapperEnergyData(const packet: TByteArray);
var voltage: longint; current: longint; energy: longint; realPower: longint; apparentPower: longint; reactivePower: longint; powerFactor: word; frequency: word;
begin
  if (Length(packet) <> 36) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  voltage := LEConvertInt32From(8, packet);
  current := LEConvertInt32From(12, packet);
  energy := LEConvertInt32From(16, packet);
  realPower := LEConvertInt32From(20, packet);
  apparentPower := LEConvertInt32From(24, packet);
  reactivePower := LEConvertInt32From(28, packet);
  powerFactor := LEConvertUInt16From(32, packet);
  frequency := LEConvertUInt16From(34, packet);
  if (Assigned(energyDataCallback)) then begin
    energyDataCallback(self, voltage, current, energy, realPower, apparentPower, reactivePower, powerFactor, frequency);
  end;
end;

end.
